#include "MIDIUSB.h"
#define MIDI_AC_INTERFACE 	pluggedInterface
#define MIDI_INTERFACE 		((uint8_t)(pluggedInterface+1))
#define MIDI_FIRST_ENDPOINT pluggedEndpoint
#define MIDI_ENDPOINT_OUT	pluggedEndpoint
#define MIDI_ENDPOINT_IN	((uint8_t)(pluggedEndpoint+1))
#define MIDI_RX MIDI_ENDPOINT_OUT
#define MIDI_TX MIDI_ENDPOINT_IN

MIDI_ MidiUSB;

int MIDI_::getInterface(uint8_t* interfaceNum){
	interfaceNum[0] += 2;
	MIDIDescriptor _midiInterface =
	{
		D_IAD(MIDI_AC_INTERFACE, 2, MIDI_AUDIO, MIDI_AUDIO_CONTROL, 0),
		D_INTERFACE(MIDI_AC_INTERFACE,0,MIDI_AUDIO,MIDI_AUDIO_CONTROL,0),
		D_AC_INTERFACE(0x1, MIDI_INTERFACE),
		D_INTERFACE(MIDI_INTERFACE,2, MIDI_AUDIO,MIDI_STREAMING,0),
		D_AS_INTERFACE,
		D_MIDI_INJACK(MIDI_JACK_EMD, 0x1),
		D_MIDI_INJACK(MIDI_JACK_EXT, 0x2),
		D_MIDI_OUTJACK(MIDI_JACK_EMD, 0x3, 1, 2, 1),
		D_MIDI_OUTJACK(MIDI_JACK_EXT, 0x4, 1, 1, 1),
		D_MIDI_JACK_EP(USB_ENDPOINT_OUT(MIDI_ENDPOINT_OUT),USB_ENDPOINT_TYPE_BULK,MIDI_BUFFER_SIZE),
		D_MIDI_AC_JACK_EP(1, 1),
		D_MIDI_JACK_EP(USB_ENDPOINT_IN(MIDI_ENDPOINT_IN),USB_ENDPOINT_TYPE_BULK,MIDI_BUFFER_SIZE),
		D_MIDI_AC_JACK_EP (1, 3)
	};
	return USB_SendControl(0, &_midiInterface, sizeof(_midiInterface));
}

bool MIDI_::setup(USBSetup& setup __attribute__((unused))){ return false; }
int MIDI_::getDescriptor(USBSetup& setup __attribute__((unused))){ return 0; }
void MIDI_::flush(void){ USB_Flush(MIDI_TX); }

size_t MIDI_::write(const uint8_t *buffer, size_t size){
	if (is_write_enabled(MIDI_TX)) {
		int r = USB_Send(MIDI_TX, buffer, size);
		if (r > 0){	return r;	} else { return 0; }
	}	return 0;
}

void MIDI_::sendMIDI(midiEventPacket_t event){
	uint8_t data[4];
	data[0] = event.header;	data[1] = event.byte1; data[2] = event.byte2;	data[3] = event.byte3;
	write(data, 4);
}

MIDI_::MIDI_(void) : PluggableUSBModule(2, 2, epType){
	epType[0] = EP_TYPE_BULK_OUT_MIDI; epType[1] = EP_TYPE_BULK_IN_MIDI; PluggableUSB().plug(this);
}
